/*!
 * scroll's style v1.1.0
 * only_wsx@163.com
 */

$(function() {
	
	// 定义域名黑名单
	var domainBlacklist = [
	"www.youtube.com",
	"another-example.com"
	];

	// 检查当前域名是否在黑名单中
	var currentUrl = window.location.hostname;
	var isBlacklisted = domainBlacklist.some(function(domain) {
		return currentUrl === domain;
	});

	if (isBlacklisted) {
		// 如果域名在黑名单中，不执行脚本的其余部分
		return;
	}


	var config = {
		backgroundColor: ['#F44336', '#E91E63', '#9C27B0', '#673AB7', '#3F51B5', '#2196F3', '#03A9F4', '#00BCD4', '#009688', '#4CAF50', '#8BC34A', '#CDDC39', '#FFEB3B', '#FFC107', '#FF9800', '#FF5722', '#795548', '#9E9E9E', '#607D8B'],
		opacity: 0.6,
		borderRadius: '4px',
		width: '8px',
		left: '20px' //距离右边宽度
	};

	var rand = parseInt(6 * Math.random());

	// 使用DocumentFragment批量添加DOM元素
	var fragment = document.createDocumentFragment();
	var wsxFade = document.createElement('div');
	wsxFade.className = 'wsx_fade';
	var wsxScroll = document.createElement('div');
	wsxScroll.className = 'wsx_scroll';
	var wsxScrollBar = document.createElement('div');
	wsxScrollBar.className = 'wsx_scroll_bar';
	wsxScroll.appendChild(wsxScrollBar);
	fragment.appendChild(wsxFade);
	fragment.appendChild(wsxScroll);
	document.body.appendChild(fragment);

	$('.wsx_scroll_bar').css({
		'background-color': config.backgroundColor[rand],
		'opacity': config.opacity,
		'-webkit-border-radius': config.borderRadius,
		'width': config.width,
		'left': config.left
	});

	var content = document.documentElement || document.body;
	var change = $(window).height();
	var scrollShow = false;
	var wsx_t;

	function upScrollHeight() {
		clearTimeout(wsx_t);
		var wHeight = $(window).height();
		var dHeight = $(document).height();
		var tmpScroll = $('.wsx_scroll');
		if (dHeight <= wHeight) {
			if (scrollShow == true) {
				tmpScroll.hide();
			}
			scrollShow = false;
		} else {
			tmpScroll.css({
				'display': 'block',
				'opacity': 1,
				'pointer-events': 'none'
			});
			scrollShow = true;
		}
		var scrollHeight = wHeight / dHeight * wHeight > 30 ? wHeight / dHeight * wHeight: 30;
		var top = $(document).scrollTop() / (dHeight - wHeight) * (wHeight - scrollHeight);
		tmpScroll.css({
			'top': top
		});
		tmpScroll.height(scrollHeight);

		wsx_t = setTimeout(function() {
			tmpScroll.css({
				'opacity': 0,
				'pointer-events': 'none'
			});
			scrollShow = false;
		},
		500);
	}

	// 使用事件委托
	$(document).on('scroll resize',
	function() {
		upScrollHeight();
	});

	var always;
	var mousedown = false;
	var in_mousedown = false;
	var startY;
	var Y;

	$(window).on('mousemove',
	function(event) {
		if ((content.clientWidth - event.clientX) < 40) {
			if (scrollShow == false) {
				upScrollHeight();
			}
			clearTimeout(wsx_t);
			always = true;
		} else {
			if (always == true) {
				always = false;
				wsx_t = setTimeout(function() {
					$('.wsx_scroll').css({
						'opacity': 0,
						'pointer-events': 'none'
					});
					scrollShow = false;
				},
				500);
			}
		}
		if (mousedown == true) {
			$('.wsx_fade').css({
				'pointer-events': 'auto'
			});
			var endY = event.clientY;
			var top = endY - startY + Y;
			if (top < 0) {
				top = 0;
			}
			var max_height = $(window).height() - $('.wsx_scroll').height();
			if (top > max_height) {
				top = max_height;
			}
			var scroll_top = top / ($(window).height() - $('.wsx_scroll').height()) * ($(document).height() - $(window).height());
			$(document).scrollTop(scroll_top);
		}
	});

	$(window).on('mousedown',
	function(event) {
		startY = event.clientY;
		Y = $(document).scrollTop() / ($(document).height() - $(window).height()) * ($(window).height() - $('.wsx_scroll').height());

		if ((content.clientWidth - event.clientX) < 12 && (content.clientWidth - event.clientX) >= 0) {
			mousedown = true;
			window.document.onselectstart = function() {
				return false;
			};
		}
	});

	$(window).on('mouseup',
	function(event) {
		document.onselectstart = null;
		mousedown = false;
		$('.wsx_fade').css({
			'pointer-events': 'none'
		});
	});
});